/*
 *	Filename: FontView.m
 *	Created : Tue May  2 01:32:50 1995
 *	Author  : Vince DeMarco <vdemarco@bou.shl.com>
 *	LastEditDate Was "Tue May  2 10:35:16 1995"
 */


#import "FontView.h"
#import "fontSample.h"
#import <appkit/FontManager.h>
#import <appkit/Font.h>
#import <appkit/Window.h>
#import <dpsclient/psops.h>

@implementation FontView

- initFrame:(const NXRect *)frameRect
{
    [super initFrame:frameRect];
    [self setFont:[Font systemFontOfSize:12.0 matrix:NX_IDENTITYMATRIX]];
    return self;
}

- (BOOL)acceptsFirstResponder
{
    return YES;
}

- becomeFirstResponder
{
    [[FontManager new] setSelFont:[self font] isMultiple:NO];
    return self;
}

- (BOOL)isOpaque
{
    return YES;
}

- drawSelf:(const NXRect *)rects :(int)rectCount
{
	if (NXDrawingStatus == NX_DRAWING){
		NXRect bnds;

		[self getBounds:&bnds];
		NXSetColor(NX_COLORWHITE);
		PSrectfill( bnds.origin.x, bnds.origin.y,
						bnds.size.width, bnds.size.height);
		PSstroke();
	}

	[Font useFont:"Helvetica"];
	[[self font] set];
	PSDisplayFontSample([[self font] name],[[self font] displayName]);
	return self;
}

- (BOOL)knowsPagesFirst:(int *)firstPageNum last:(int *)lastPageNum
{
    *firstPageNum = *lastPageNum = 1;
    return YES;
}

- (BOOL)getRect:(NXRect *)theRect forPage:(int)page
{
    if (page == 1){
	theRect->origin.x   = 0.0;
	theRect->origin.y   = 0.0;
	theRect->size.width = 612.0;
	theRect->size.height= 792.0;
	return YES;
    }
    return NO;
}

- setFont:(Font *)aFont
{
    currentFont = aFont;
    [self update];
    return self;
}

- (Font *)font
{
    return currentFont;
}

- changeFont:sender
{
    [self setFont:[[FontManager new] convertFont:[self font]]];
    return self;
}

- print:sender
{
    [self printPSCode:sender];
    return self;
}

@end
